<?php
if(class_exists("Gc_Message_Bar_Controller")){
    return;
}
class Gc_Message_Bar_Controller implements Gc_MessageBar_Controller_Interface {
	public $options;
    protected $namespace;		
    protected $renderer = null;
    
    public function __construct($namespace){
        $this->namespace = $namespace;

    }

    public function initialize(){
        $this->options = GCCF::create("Option_Repository_Factory")->get_instance()->get_namespace($this->namespace);

        $this->renderer = new Gc_Message_Bar_Renderer($this->namespace, $this);
    }

    public function initialize_hooks(){
        add_action( 'init', array($this, 'scripts_init') );
		add_action( 'wp_footer', array($this, 'render_bar') );
	}
	
    public function handle_request(){

    }
    
    public function scripts_init(){
		wp_enqueue_script( 'jquery' );
		wp_register_style( 'generated', plugins_url('style-gc-message-bar.php', dirname(__FILE__)) );
		wp_enqueue_style( 'generated' );
		wp_register_script( 'jquerycookie', plugins_url('jquery.cake.js', __FILE__) );
		wp_enqueue_script( 'jquerycookie' );
		wp_register_script( 'jqueryeasing', plugins_url('jquery.easing.js', __FILE__) );
		wp_enqueue_script( 'jqueryeasing' );
		
		wp_register_style( 'google_webfonts', 'http://fonts.googleapis.com/css?family=Droid+Sans:400,700|Lato:100,300,400,700,900,100italic,300italic,400italic,700italic,900italic|PT+Sans:400,700,400italic,700italic|Bitter:400,700,400italic|Droid+Serif:400,700,700italic,400italic|Open+Sans:300italic,400italic,600italic,700italic,800italic,400,800,700,600,300|Oswald:400,700,300|Open+Sans+Condensed:300,300italic,700|Yanone+Kaffeesatz:400,700,300,200|Roboto:400,900italic,700italic,900,700,500italic,500,400italic,300italic,300,100italic,100&subset=latin,latin-ext,cyrillic,cyrillic-ext,greek-ext,greek,vietnamese' );
		wp_enqueue_style('google_webfonts');
    }

	public function render_bar() {
		$this->renderer->render("");
	}
	
}
