<?php
if(!class_exists("Gc_Message_Bar")){
    class Gc_Message_Bar{
        protected $options;

        public function __construct($namespace) {
            $this->namespace = $namespace;
            $this->options = Gc_Option_Repository_Factory::get_instance()->get_namespace($namespace);
            
        }
        protected $color_sets = array(
                /*   bg1          bg2      message     butbg1     butbg2      borderc.    buttextc.   hover1      hover2   hoverborder  hovertext */
                "['#3faace', '#027ea9', '#ffffff', '#b9d245', '#778d29', '#778d29', '#ffffff', '#f6e155', '#cea72e', '#c49f25', '#005c83', '1', '2','2','1', '1']", //BLUe
                "['#b9d245', '#778d29', '#ffffff', '#f6e155', '#cea72e', '#c49f25', '#005c83', '#3faace', '#027ea9', '#027ea9', '#ffffff', '1', '2','1','2', '2']", //GReeN
                "['#ee6b6b', '#d21d1d', '#ffffff', '#f6e155', '#cea72e', '#c49f25', '#005c83', '#3faace', '#027ea9', '#027ea9', '#ffffff', '1', '2','1','2', '1']", //ReD
                "['#f6a255', '#d2741d', '#ffffff', '#3faace', '#027ea9', '#027ea9', '#ffffff', '#b9d245', '#778d29', '#778d29', '#ffffff', '1', '2','2','2', '1']", //ORANGe
                "['#b7b7b7', '#969696', '#ffffff', '#ee6b6b', '#d21d1d', '#d21d1d', '#ffffff', '#3faace', '#027ea9', '#027ea9', '#ffffff', '1', '2','2','2', '1']", //GRAY
                "['#191919', '#000000', '#ffffff', '#ee6b6b', '#d21d1d', '#d21d1d', '#ffffff', '#b9d245', '#778d29', '#778d29', '#ffffff', '1', '2','2','2', '1']", //BLACK
                "['#ffffff', '#eeeeee', '#000000', '#ee6b6b', '#d21d1d', '#d21d1d', '#ffffff', '#b9d245', '#778d29', '#778d29', '#ffffff', '1', '1','2','2', '1']"  //WHITe
            );

        protected function get_predefined_colors($set = 0) {
                        
            return $this->color_sets[$set];
        }
        protected function get_predefined_colors_count(){
            return count($this->color_sets);
        }

        public function handle_request(){
            if (!isset($_REQUEST['Submit_gc_message_bar']) or !isset($_REQUEST['post'])) {
                return;
            }

            $options = $this->get_options();

            foreach($options as $option) {
                if (isset($_REQUEST['post'][$option->get_name()])) {
                    $option->set_value($_REQUEST['post'][$option->get_name()]);
                    $option->save();
                } elseif($option->is_checkbox()) {
                    $option->set_checked(false);
                }else{
                    continue;
                }
                $option->save();
            }

        }
/*
        public function sub_menu() {
            $this->add_submenu_page( 'plugins.php', 'GC Message Box Options', 'GC Message Box','manage_options', 'gc_message_box', array($this, 'sub_menu_page'));
        }

        protected function add_submenu_page ($parent, $pageTitle, $menuTitle, $capability, $ident, $function) {
            add_submenu_page( $parent, $pageTitle, $menuTitle, $capability, $ident, $function );
        }

        public function get_options(){
            return $this->options->get_options();

        }    


        public function init_values() {
            $installed = $this->options->get("installed")->get_value();
            if ($installed == "true") {
                return;
            }
            $options = $this->get_options();
            foreach ($options as $key => $opt) {
                $opt->save();
            }
           
        }
        */
        protected function get_general_options(){
            return $this->options->filter_options_by_group("general");
        }

        protected function get_style_options(){
            return $this->options->filter_options_by_group("style");
        }

        /*
        public function sub_menu_page() {
            global $GC_Message_Box_Config;
            $this->init_values();
            if ( !current_user_can( 'manage_options' ) )  {
                wp_die( __( 'You do not have sufficient permissions to access this page.' ) );
            }
            ?>
            <div id="gc_message_box_admin">
                <h2>GC Message Box</h2>
                <div class="wrap">
                    <div class="mainmessage">
                        Have questions or wanna suggest an idea? Visit the <a href="<?php echo $GC_Message_Box_Config['GCHOME']; ?>/forum?utm_source=gc_message_box_text&utm_medium=top_message&utm_campaign=discuss_forum" target="_blank">GC Message Box forum</a>
                    </div>
                    <form method="post" id="updateSettings">
                    <?php $this->render_general_settings(); ?>
                    <div class="submit">
                        <input name="Submit_gc_message_box" type="submit" class="button-primary" value="Save Changes" />
                    </div>
                    <?php $this->render_style_settings(); ?>
                    <div class="submit bottom">
                        <input name="Submit_gc_message_box" type="submit" class="button-primary" value="Save Changes" />
                    </div>
                    <div class="copy">GC Message Box plugin for WordPress by <a class="gcmblink" href="<?php echo $GC_Message_Box_Config['GCHOME']; ?>/?utm_source=gc_message_box_text&utm_medium=copy_message&utm_campaign=home" target="_blank">GetConversion</a><br />Current version: <?php echo getMessageBoxVersion(); ?></div>
                    </form>
                </div>
                <div id="gc_ad">
                    <iframe id="gc_message_box_banners" src="<?php echo $GC_Message_Box_Config['GCHOME'].$GC_Message_Box_Config['GCSERVICES'].'/gcmessageboxad';?>"></iframe>
                </div>
                <div class="clear"></div>
            </div>
            <?php
        }
        
        
        protected function render_style_settings() {
            wp_nonce_field( 'admin_init' );
            do_settings_sections( 'style_options' );
            settings_fields( 'style_options' ); ?>
            <div id="style-elements" class="<?php echo $this->namespace;?>admin">
                <table class="form-table">
                    <tbody>
                        <?php 
                            $options = $this->get_style_options();
                            foreach($options as $id => $option) {
                        ?>
                        <tr id="<?php echo $id; ?>_row">
                            <th scope="row" style="text-align: right; vertical-align: top;">
                                <?php echo __($option->get_text()); ?>
                            </th>
                            <td>
                                <?php if($option->is_color()) { 
                                    $this->render_color_option($option);
                                } 
                                if ($option->is_checkbox()) {
                                    $this->render_checkbox_option($option);
                                }
                                if ($option->is_radio()) {
                                    $this->render_radio($option);
                                }
                                if ($option->is_number()) {
                                    $this->render_number_option($option);
                                }
                                ?>
                            </td>
                        </tr>
                        <? } ?>
                    </tbody>
                </table><div class="clear"></div>
            </div><?
        }

        protected function render_general_settings() {
            wp_nonce_field( 'update-options' );
            do_settings_sections( 'general_options' );
            settings_fields( 'general_settings' ); ?>
            <div id="general-elements" class="<?php echo $this->namespace;?>admin">
                <table class="form-table">
                    <tbody>
                        <?php 
                            $options = $this->get_general_options();
                            foreach($options as $id => $option) {
                        ?>
                        <tr id="<?php echo $id; ?>_row">
                            <th scope="row" style="text-align: right; vertical-align: top;"><?php echo __($option->get_text()); ?></th>
                            <td>
                                <?php if($option->is_text()) { 
                                    $this->render_text($option);
                                } 
                                if ($option->is_checkbox()) {
                                    $this->render_checkbox($option);
                                }
                                if ($option->is_text_area()) {
                                    $this->render_text_area($option);
                                }
                                if ($option->is_select()) {
                                    $this->render_select($option);
                                }
                                if ($option->is_radio()) {
                                    $this->render_radio($option);
                                }
                                if ($option->is_number()) {
                                    $this->render_number_option($option);
                                }
                                 ?>
                            </td>
                        </tr>
                        <?php } ?>
                        <tr>
                            <th scope="row" style="text-align: right; vertical-align: top;"><?php echo __('Predefined Color Sets:') ?></th>
                            <td>
                                <select id="<?php echo $this->namespace; ?>predefined">
                                    <option selected="selected" disabled="disabled" value="none"><?php echo __('Select a predefined set') ?></option>
                                    <option style="padding: 5px; color: #000000; font-weight: bold; background-color: #3faace;" value="0"><?php echo __('Blue') ?></option>
                                    <option style="padding: 5px; color: #FFFFFF; font-weight: bold; background-color: #b9d245;" value="1"><?php echo __('Green') ?></option>
                                    <option style="padding: 5px; color: #000000; font-weight: bold; background-color: #ee6b6b;" value="2"><?php echo __('Red') ?></option>
                                    <option style="padding: 5px; color: #FFFFFF; font-weight: bold; background-color: #f6a255;" value="3"><?php echo __('Orange') ?></option>
                                    <option style="padding: 5px; color: #000000; font-weight: bold; background-color: #b7b7b7;" value="4"><?php echo __('Gray') ?></option>
                                    <option style="padding: 5px; color: #FFFFFF; font-weight: bold; background-color: #000000;" value="5"><?php echo __('Black') ?></option>
                                    <option style="padding: 5px; color: #000000; font-weight: bold; background-color: #FFFFFF;" value="6"><?php echo __('White') ?></option>
                                </select>
                            </td>
                        </tr>
                    </tbody>
                </table>
                <input type="hidden" name="hidden" />
            </div>
            <script type="text/javascript" src="<?php echo get_bloginfo('wpurl'); ?>/wp-admin/js/farbtastic.js"></script>
            <script type="text/javascript">
                var GC = {};
                GC.MessageBox = {
                    sets : [<?php for ($i=0; $i<$this->get_predefined_colors_count(); ++$i) { echo $this->get_predefined_colors($i).", "; } ?>],
                    current : [<?php 
                        $colors = $this->options->filter_options_by_type("color");
                        $colorValues = array();
                        foreach($colors as $key => $color){
                            $colorValues[] = "'" . $color->get_value(). "'";
                        }
                        echo implode(',',$colorValues);
                    ?>],
                    colorPickerSetup : function () {
                        <?php
                        foreach($colors as $key => $color) : ?>
                        jQuery('#<?php echo $color->get_name(); ?>_cp').hide();
                        jQuery('#<?php echo $color->get_name(); ?>_cp').farbtastic("#<?php echo $color->get_name(); ?>");
                        jQuery("#<?php echo $color->get_name(); ?>").click(function(){
                            jQuery(".colorpickers:not([id=\"<?php echo $color->get_name(); ?>_cp\"])").slideUp('medium');
                            jQuery('#<?php echo $color->get_name(); ?>_cp').slideToggle('medium');
                        });
                        <?php endforeach; ?>    
                    },
                    trigger : function () {
                        //Predefined colors change
                        GC.MessageBox.changeColors(GC.MessageBox.current);
                        jQuery("#<?php echo $this->namespace; ?>predefined").change(function() {
                            GC.MessageBox.changeColors(GC.MessageBox.sets[jQuery("#<?php echo $this->namespace; ?>predefined option:selected").val()]);
                        });
                        
                        //Enable repeat hiding
                        if (jQuery("#<?php echo $this->namespace; ?>enable_repeat").is(':checked')) {
                            jQuery("#repeat_after_row").show();
                        } else {
                            jQuery("#repeat_after_row").hide();
                        }
                        jQuery("#<?php echo $this->namespace; ?>enable_repeat").change(function() {
                            if (jQuery("#<?php echo $this->namespace; ?>enable_repeat").is(':checked')) {
                                jQuery("#repeat_after_row").show();
                            } else {
                                jQuery("#repeat_after_row").hide();
                            }
                        });
                        
                        //Appear here hiding
                        if (jQuery("#<?php echo $this->namespace; ?>appear_here_1:checked").val() === "1") {
                            jQuery("#appear_here_home_row").hide();
                            jQuery("#appear_here_category_row").hide();
                            jQuery("#appear_here_tag_row").hide();
                            jQuery("#appear_here_archive_row").hide();
                            jQuery("#appear_here_author_row").hide();
                            jQuery("#appear_here_search_row").hide();
                            jQuery("#appear_here_article_row").hide();
                        } else {
                            jQuery("#appear_here_home_row").show();
                            jQuery("#appear_here_category_row").show();
                            jQuery("#appear_here_tag_row").show();
                            jQuery("#appear_here_archive_row").show();
                            jQuery("#appear_here_author_row").show();
                            jQuery("#appear_here_search_row").show();
                            jQuery("#appear_here_article_row").show();
                        }
                        jQuery("[name=\"post[gc_message_box_appear_here]\"]").change(function() {
                            if (jQuery("#<?php echo $this->namespace; ?>appear_here_1:checked").val() === "1") {
                                jQuery("#appear_here_home_row").hide();
                                jQuery("#appear_here_category_row").hide();
                                jQuery("#appear_here_tag_row").hide();
                                jQuery("#appear_here_archive_row").hide();
                                jQuery("#appear_here_author_row").hide();
                                jQuery("#appear_here_search_row").hide();
                                jQuery("#appear_here_article_row").hide();
                            } else {
                                jQuery("#appear_here_home_row").show();
                                jQuery("#appear_here_category_row").show();
                                jQuery("#appear_here_tag_row").show();
                                jQuery("#appear_here_archive_row").show();
                                jQuery("#appear_here_author_row").show();
                                jQuery("#appear_here_search_row").show();
                                jQuery("#appear_here_article_row").show();
                            }
                        });
                    },
                    shadows : function() {
                        
                        if (jQuery("#<?php echo $this->namespace; ?>text_shadow:checked").val() === "1") {
                            jQuery("#message_shadow_row").show();
                            jQuery("#button_shadow_row").show();
                            jQuery("#button_hover_shadow_row").show();
                        } else {
                            jQuery("#message_shadow_row").hide();
                            jQuery("#button_shadow_row").hide();
                            jQuery("#button_hover_shadow_row").hide();
                        }
                        jQuery("#<?php echo $this->namespace; ?>text_shadow").change(function() {
                            if (jQuery("#<?php echo $this->namespace; ?>text_shadow").is(':checked')) {
                                jQuery("#message_shadow_row").show();
                                jQuery("#button_shadow_row").show();
                                jQuery("#button_hover_shadow_row").show();
                            } else {
                                jQuery("#message_shadow_row").hide();
                                jQuery("#button_shadow_row").hide();
                                jQuery("#button_hover_shadow_row").hide();
                            }
                        });
                    },
                    changeColors : function (set) {
                        <?php 
                        $i=0;
                        foreach($colors as $key => $color) { ?>
                                jQuery('#<?php echo $color->get_name(); ?>').val(set[<?php echo strtolower($i); ?>]);
                                jQuery.farbtastic('#<?php echo $color->get_name(); ?>_cp').setColor(set[<?php echo strtolower($i); ?>]);
                                <?php $i++; ?>
                        <?php } ?>
                            if(set[11] === "1"){
                                jQuery("#<?php echo $this->namespace; ?>text_shadow").prop('checked', set[11]);
                            }
                            
                            jQuery("#message_shadow_row input").each(function() {
                                console.log(jQuery(this).val());
                                console.log(set[12]);
                                if (jQuery(this).val() == set[12])
                                    jQuery(this).prop('checked', true);
                                else jQuery(this).prop('checked', false);
                            });
                            jQuery("#button_shadow_row input").each(function() {
                                if (jQuery(this).val() == set[13])
                                    jQuery(this).prop('checked', true);
                                else jQuery(this).prop('checked', false);
                            });
                            jQuery("#button_hover_shadow_row input").each(function() {
                                if (jQuery(this).val() == set[14])
                                    jQuery(this).prop('checked', true);
                                else jQuery(this).prop('checked', false);
                            });
                            GC.MessageBox.shadows();
                    },
                    Appear : false,
                    Init : function () {
                        GC.MessageBox.colorPickerSetup();
                        GC.MessageBox.trigger();
                        GC.MessageBox.shadows();
                    }
                };

                jQuery(document).ready(function() {
                    GC.MessageBox.Init();
                });
            </script>
        <?php
        }


/*
        protected function render_radio($option){
            foreach($option->get_options() as $value => $text) :  ?>
            <div><input type="radio" <?php if($option->get_value() == $value) echo "checked"; ?> value="<?php echo $value;?>" name="post[<?php echo $option->get_name(); ?>]" id="<?php echo $option->get_name().'_'.$value; ?>" /><?php echo __($text) ?></div>
            <?php endforeach; 

        }

        protected function render_number_option($option){
            ?>
                <input type="number" name="post[<?php echo $option->get_name(); ?>]" value="<?php echo $option->get_value(); ?>" min="0" />
                <span class="<?php echo $this->namespace; ?>description"><?php echo $option->get_description(); ?></span>
            <?php

        }

        protected function render_checkbox_option($option){
            ?>
                <input <?php if($option->is_checked()) echo "checked=\"checked\""; ?> id="<?php echo $option->get_name(); ?>" type="checkbox" name="post[<?php echo $option->get_name(); ?>]" value="1" />
            <?php

        }
        protected function render_color_option($option){
            ?>
            <input type="text" id="<?php echo $option->get_name(); ?>" name="post[<?php echo $option->get_name(); ?>]" value="<?php echo $option->get_value(); ?>" />
            <div class="colorpickers" id="<?php echo $option->get_name($key); ?>_cp"></div>
            <?php
        }

        protected function render_text_area($option){
            ?>
                <textarea id="<?php echo $option->get_name(); ?>" name="post[<?php echo $option->get_name(); ?>]"><?php echo $option->get_value(); ?></textarea>
                <span class="<?php echo $this->namespace; ?>description"><?php echo $option->get_description(); ?></span>
            <?php

        }

        protected function render_text($option){
            ?>
            <input type="text" id="<?php echo $option->get_name(); ?>" name="post[<?php echo $option->get_name(); ?>]" value="<?php echo $option->get_value(); ?>" />
            <span class="<?php echo $this->namespace; ?>description"><?php echo $option->get_description(); ?></span>
            <?php 
        }

        protected function render_checkbox($option){
            ?>
                <input <?php if($option->is_checked()) echo "checked=\"checked\""; ?> type="checkbox" id="<?php echo $option->get_name($key); ?>" name="post[<?php echo $option->get_name(); ?>]" value="1" />
            <?php

        }

        protected function render_select($option){
            ?>
                <select id="<?php echo $option->get_name(); ?>" name="post[<?php echo $option->get_name(); ?>]">
                    <?php foreach($option->get_options() as $value => $text) : ?>
                    <option <?php if($option->get_value() == $value) echo "selected=\"selected\""; ?> value="<?php echo $value;?>"><?php echo __($text) ?></option>
                    <?php endforeach; ?>

                </select>
            <?php

        }

/*
        public function admin_init() {
            add_settings_section( 'style_settings', 'Style Settings', array($this, 'style_sub_message'), 'style_options');
            add_settings_section( 'general_settings', 'General Settings', array($this, 'general_sub_message'), 'general_options');
        }
        
        public function style_sub_message() {
            __( 'Options for styling the GC Message Box' );
            echo "<br />";
        }
        
        public function general_sub_message() {
            __( 'General options for the GC Message Box' );
            echo "<br />";
        }
        
        

/*      
        public function scripts_init() {
            wp_enqueue_style( 'farbtastic' );
            wp_register_style( 'gc_message_box_generated_style', plugins_url('style-gc-message-box.php', __FILE__) );
            wp_enqueue_style( 'gc_message_box_generated_style' );
            wp_enqueue_script( 'jquery' );
            wp_enqueue_script( 'farbtastic' );
        }
*/

    }
}